
# Written by Kuroda Daisuke(Dycoon).
# This file is PUBLIC DOMAIN.

require "rexml/document"
include REXML


#
fname = ARGV[0]

f = open(fname, 'r')
doc = f.read.to_s
f.close

#print doc

#
xmldoc = REXML::Document.new(doc)


elems = xmldoc.elements

images = []

elems.each("COLLADA/library_images/image"){|i|
  print "#{i.attributes["name"]}\n"

  images.push(i.attributes["name"])
}

elems.each("COLLADA/library_images/image/init_from"){|i|
  print "#{i.text}\n"

  i.text = i.text.gsub("file://", "")
  i.text = i.text.gsub(".tga", ".png")

  print "#{i.text}\n"
}

pat = "(" + images.join(")|(") + ")"
print "pat = #{pat}\n"
pat = Regexp.new(pat)

elems.each("COLLADA/library_effects/effect"){|i|
  mch = pat.match(i.attributes["name"])
  if mch
    e = i.elements
    e.each("profile_COMMON"){|j|
      #
      newparam = Element.new("newparam")
      newparam.attributes["sid"] = mch[0] + "-surface"
      
      surface = Element.new("surface")
      surface.attributes["type"] = "2D"

      init_from = Element.new("init_from")
      init_from.text = mch[0] + "-image"

      _format = Element.new("format")
      _format.text = "A8R8G8B8"

      surface.add_element(init_from)
      surface.add_element(_format)

      newparam.add_element(surface)

      j.add_element(newparam)

      #
      newparam = Element.new("newparam")
      newparam.attributes["sid"] = mch[0] + "-sampler"

      sampler2D = Element.new("sampler2D")

      source = Element.new("source")
      source.text = mch[0] + "-surface"

      minfilter = Element.new("minfilter")
      minfilter.text = "LINEAR_MIPMAP_LINEAR"

      magfilter = Element.new("magfilter")
      magfilter.text = "LINEAR"

      sampler2D.add_element(source)
      sampler2D.add_element(minfilter)
      sampler2D.add_element(magfilter)

      newparam.add_element(sampler2D)

      j.add_element(newparam)

      j.elements.each("technique/lambert/diffuse"){|k|
        k.elements.delete_all("color")

        texture = Element.new("texture")
        texture.attributes["texcoord"] = "CHANNEL1"
        texture.attributes["texture"] = mch[0] + "-sampler"

        k.add_element(texture)
      }

    }
  end
}

#
fname = ARGV[1]

f = open(fname, 'w')
f.binmode
f.write xmldoc.to_s
f.close

