package  
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.text.TextField;
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.objects.DisplayObject3D;
	import org.papervision3d.objects.parsers.DAE;
	import org.papervision3d.render.BasicRenderEngine;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.view.Viewport3D;
	/**
	 * ...
	 * @author kuroda daisuke
	 */
	public class PapervisionSampleView extends Sprite
	{
		private var viewport : Viewport3D;
		private var camera : Camera3D;
		private var scene : Scene3D;
		private var renderer : BasicRenderEngine;
		
		private var walker : DAE = null;
		
		private var text : TextField = null;
		
		public function PapervisionSampleView() 
		{
			renderer = new BasicRenderEngine();
			
			viewport = new Viewport3D(500,200,true,true);
			viewport.opaqueBackground = 0x000000;
			addChild( viewport);
			
			camera = new Camera3D();
			camera.x = -10;
			camera.y = 10;
			camera.z = -10;
			camera.focus = 50;
			camera.zoom = 20;
			
			var target : DisplayObject3D;
			target = new DisplayObject3D();
			target.x = 0;
			target.y = 2;
			target.z = 0;
			camera.target = target;
			
			
			scene = new Scene3D();
			
			createObject();
			
			addEventListener(Event.ENTER_FRAME, onRenderTick);
			
			createTextField();
		}
		
		public function createObject() : void
		{
			walker = new DAE(true);
			walker.addFileSearchPath("data");
			walker.load("data/walker.dae");
			
			walker.play();
			
			scene.addChild(walker);
			
		}
		
		public function createTextField() : void
		{
			text = new TextField();
			text.textColor = 0xffffffff;
			text.width = 800;
			text.text = "Copyright 2006-2008 (c) Carlos Ulloa Matesanz, noventaynueve.com.";
			addChild(text);
		}
		
		public function onRenderTick(event : Event = null) : void
		{
			if (!walker.playing)
			{
				walker.play();
			}
			
			renderer.renderScene( scene , camera, viewport );
			
		}
		
		
		
	}

}